window.Gleam.initSearch([{"doc":"glcode","title":"glcode","content":"# glcode\n\nThis package provides Gleam bindings to Erlang&#39;s `code` module.\n\nWith this library, hot module reloading and introspection into module internals\nis possible.\n","url":"index.html"},{"doc":"glcode","title":"AddPathError","content":"pub type AddPathError {\n  AddPathBadDirectory\n}\n\nAddPathBadDirectory\n given dir is not a directory\n\nSynonyms:\nglcode.AddPathError\nglcode AddPathError","url":"glcode.html#AddPathError"},{"doc":"glcode","title":"Anno","content":"pub type Anno {\n  Anno(file: String, location: Int)\n  AnnoNone\n}\n\nAnno(file: String, location: Int)\n\n\nAnnoNone\n\n\nSynonyms:\nglcode.Anno\nglcode Anno","url":"glcode.html#Anno"},{"doc":"glcode","title":"AtomicLoadError","content":"pub type AtomicLoadError {\n  AtomicLoadBadFile(module: String)\n  AtomicLoadDuplicated(module: String)\n  AtomicLoadNoFile(module: String)\n  AtomicLoadNotPurged(module: String)\n  AtomicLoadOnLoadNotAllowed(module: String)\n  AtomicLoadPendingOnLoad(module: String)\n  AtomicLoadStickyDirectory(module: String)\n}\n\nAtomicLoadBadFile(module: String)\n The object code has an incorrect format or the module name in the object code is not the expected module name.\n\nAtomicLoadDuplicated(module: String)\n A module is included more than once in Modules.\n\nAtomicLoadNoFile(module: String)\n No file with object code exists.\n\nAtomicLoadNotPurged(module: String)\n The object code cannot be loaded because an old version of the code already exists.\n\nAtomicLoadOnLoadNotAllowed(module: String)\n A module contains an -on_load function.\n\nAtomicLoadPendingOnLoad(module: String)\n A previously loaded module contains an `-on_load` function that never finished.\n\nAtomicLoadStickyDirectory(module: String)\n The object code resides in a sticky directory.\n\nSynonyms:\nglcode.AtomicLoadError\nglcode AtomicLoadError","url":"glcode.html#AtomicLoadError"},{"doc":"glcode","title":"Available","content":"pub type Available {\n  Available(module: String, filename: String, loaded: Bool)\n  AvailablePreloaded(module: String, loaded: Bool)\n  AvailableCoverCompiled(module: String, loaded: Bool)\n}\n\nAvailable(module: String, filename: String, loaded: Bool)\n `filename` is normally the absolute filename, as described for\n `is_loaded`.\n\nAvailablePreloaded(module: String, loaded: Bool)\n\n\nAvailableCoverCompiled(module: String, loaded: Bool)\n\n\nSynonyms:\nglcode.Available\nglcode Available","url":"glcode.html#Available"},{"doc":"glcode","title":"DeletePathError","content":"pub type DeletePathError {\n  DeletePathBadName\n  DeletePathNotFound\n}\n\nDeletePathBadName\n given dir is invalid\n\nDeletePathNotFound\n given dir is wasn&#39;t found\n\nSynonyms:\nglcode.DeletePathError\nglcode DeletePathError","url":"glcode.html#DeletePathError"},{"doc":"glcode","title":"DocsV1","content":"pub type DocsV1 {\n  DocsV1(\n    anno: Anno,\n    beam_language: String,\n    format: String,\n    module_doc: ModuleDoc,\n    metadata: dict.Dict(String, MetadataValue),\n    docs: List(String),\n  )\n}\n\nDocsV1(\n  anno: Anno,\n  beam_language: String,\n  format: String,\n  module_doc: ModuleDoc,\n  metadata: dict.Dict(String, MetadataValue),\n  docs: List(String),\n)\n\n\nSynonyms:\nglcode.DocsV1\nglcode DocsV1","url":"glcode.html#DocsV1"},{"doc":"glcode","title":"EnsureLoadedError","content":"pub type EnsureLoadedError {\n  EnsureLoadedEmbedded\n  EnsureLoadedBadFile\n  EnsureLoadedNoFile\n  EnsureLoadedOnLoadFailure\n}\n\nEnsureLoadedEmbedded\n modules cannot be loaded in embedded mode\n\nEnsureLoadedBadFile\n The object code has an incorrect format or the module name in the object\n code is not the expected module name.\n\nEnsureLoadedNoFile\n No file with object code was found.\n\nEnsureLoadedOnLoadFailure\n The module has an `-on_load` function that failed when it was called.\n\nSynonyms:\nglcode.EnsureLoadedError\nglcode EnsureLoadedError","url":"glcode.html#EnsureLoadedError"},{"doc":"glcode","title":"EnsureModulesLoadedError","content":"pub type EnsureModulesLoadedError {\n  EnsureModulesLoadedBadfile(module: String)\n  EnsureModulesLoadedNofile(module: String)\n  EnsureModulesLoadedOnLoadFailure(module: String)\n}\n\nEnsureModulesLoadedBadfile(module: String)\n\n\nEnsureModulesLoadedNofile(module: String)\n\n\nEnsureModulesLoadedOnLoadFailure(module: String)\n\n\nSynonyms:\nglcode.EnsureModulesLoadedError\nglcode EnsureModulesLoadedError","url":"glcode.html#EnsureModulesLoadedError"},{"doc":"glcode","title":"FinishLoadingError","content":"pub type FinishLoadingError {\n  FinishLoadingNotPurged(module: String)\n  FinishLoadingStickyDirectory(module: String)\n  FinishLoadingPendingOnLoad(module: String)\n}\n\nFinishLoadingNotPurged(module: String)\n The object code cannot be loaded because an old version of the code\n already exists.\n\nFinishLoadingStickyDirectory(module: String)\n The object code resides in a sticky directory.\n\nFinishLoadingPendingOnLoad(module: String)\n A previously loaded module contains an `-on_load` function that never\n finished.\n\nSynonyms:\nglcode.FinishLoadingError\nglcode FinishLoadingError","url":"glcode.html#FinishLoadingError"},{"doc":"glcode","title":"GetDocError","content":"pub type GetDocError {\n  GetDocNonExisting\n  GetDocMissing\n  GetDocPosix(error: String)\n}\n\nGetDocNonExisting\n\n\nGetDocMissing\n\n\nGetDocPosix(error: String)\n\n\nSynonyms:\nglcode.GetDocError\nglcode GetDocError","url":"glcode.html#GetDocError"},{"doc":"glcode","title":"IsLoaded","content":"pub type IsLoaded {\n  IsLoaded(filename: String)\n  IsPreloaded\n  IsCoverCompiled\n}\n\nIsLoaded(filename: String)\n\n\nIsPreloaded\n\n\nIsCoverCompiled\n\n\nSynonyms:\nglcode.IsLoaded\nglcode IsLoaded","url":"glcode.html#IsLoaded"},{"doc":"glcode","title":"LibDirOfError","content":"pub type LibDirOfError {\n  LibDirOfBadName\n}\n\nLibDirOfBadName\n\n\nSynonyms:\nglcode.LibDirOfError\nglcode LibDirOfError","url":"glcode.html#LibDirOfError"},{"doc":"glcode","title":"LoadError","content":"pub type LoadError {\n  LoadFileBadFile\n  LoadFileNoFile\n  LoadFileNotPurged\n  LoadFileOnLoadFailure\n  LoadFileStickyDirectory\n  LoadFileBadArg\n}\n\nLoadFileBadFile\n The object code has an incorrect format or the module name in the object code is not the expected module name.\n\nLoadFileNoFile\n No file with object code was found.\n\nLoadFileNotPurged\n The object code could not be loaded because an old version of the code already existed.\n\nLoadFileOnLoadFailure\n The module has an -on_load function that failed when it was called.\n\nLoadFileStickyDirectory\n The object code resides in a sticky directory.\n\nLoadFileBadArg\n name or dir is invalid\n\nSynonyms:\nglcode.LoadError\nglcode LoadError","url":"glcode.html#LoadError"},{"doc":"glcode","title":"Loaded","content":"pub type Loaded {\n  Loaded(module: String, filepath: String)\n  LoadedPreloaded(module: String)\n  LoadedCoverCompiled(module: String)\n}\n\nLoaded(module: String, filepath: String)\n\n\nLoadedPreloaded(module: String)\n\n\nLoadedCoverCompiled(module: String)\n\n\nSynonyms:\nglcode.Loaded\nglcode Loaded","url":"glcode.html#Loaded"},{"doc":"glcode","title":"MetadataValue","content":"pub type MetadataValue {\n  OtpDocVsn(Int, Int, Int)\n}\n\nOtpDocVsn(Int, Int, Int)\n\n\nSynonyms:\nglcode.MetadataValue\nglcode MetadataValue","url":"glcode.html#MetadataValue"},{"doc":"glcode","title":"Mode","content":"pub type Mode {\n  Interactive\n  Embedded\n}\n\nInteractive\n\n\nEmbedded\n\n\nSynonyms:\nglcode.Mode\nglcode Mode","url":"glcode.html#Mode"},{"doc":"glcode","title":"Module","content":"pub type Module {\n  ModuleName(String)\n  ModuleObject(ObjectCode)\n}\n\nModuleName(String)\n\n\nModuleObject(ObjectCode)\n\n\nSynonyms:\nglcode.Module\nglcode Module","url":"glcode.html#Module"},{"doc":"glcode","title":"ModuleDoc","content":"pub type ModuleDoc {\n  ModuleDocNone\n  ModuleDocHidden\n  ModuleDoc(dict.Dict(String, Dynamic))\n}\n\nModuleDocNone\n\n\nModuleDocHidden\n\n\nModuleDoc(dict.Dict(String, Dynamic))\n\n\nSynonyms:\nglcode.ModuleDoc\nglcode ModuleDoc","url":"glcode.html#ModuleDoc"},{"doc":"glcode","title":"ModuleStatus","content":"pub type ModuleStatus {\n  ModuleStatusNotLoaded(module: String)\n  ModuleStatusLoaded(module: String)\n  ModuleStatusRemoved(module: String)\n  ModuleStatusModified(module: String)\n}\n\nModuleStatusNotLoaded(module: String)\n If `module` is not currently loaded\n\nModuleStatusLoaded(module: String)\n If `module` is loaded and the object file exists and contains the same code\n\nModuleStatusRemoved(module: String)\n If `module` is loaded but no corresponding object file can be found in the code path\n\nModuleStatusModified(module: String)\n If `module` is loaded but the object file contains code with a different MD5 checksum\n\nSynonyms:\nglcode.ModuleStatus\nglcode ModuleStatus","url":"glcode.html#ModuleStatus"},{"doc":"glcode","title":"ObjectCode","content":"pub type ObjectCode {\n  Object(module: String, binary: BitArray, filename: String)\n}\n\nObject(module: String, binary: BitArray, filename: String)\n\n\nSynonyms:\nglcode.ObjectCode\nglcode ObjectCode","url":"glcode.html#ObjectCode"},{"doc":"glcode","title":"PathOrName","content":"pub type PathOrName {\n  Path(String)\n  Name(String)\n}\n\nPath(String)\n\n\nName(String)\n\n\nSynonyms:\nglcode.PathOrName\nglcode PathOrName","url":"glcode.html#PathOrName"},{"doc":"glcode","title":"PrepareLoadingError","content":"pub type PrepareLoadingError {\n  PrepareLoadingBadFile(module: String)\n  PrepareLoadingNoFile(module: String)\n  PrepareLoadingOnLoadNotAllowed(module: String)\n  PrepareLoadingDuplicated(module: String)\n}\n\nPrepareLoadingBadFile(module: String)\n The object code has an incorrect format or the module name in the object\n code is not the expected module name.\n\nPrepareLoadingNoFile(module: String)\n No file with object code exists.\n\nPrepareLoadingOnLoadNotAllowed(module: String)\n A module contains an `-on_load` function.\n\nPrepareLoadingDuplicated(module: String)\n A module is included more than once in `modules`.\n\nSynonyms:\nglcode.PrepareLoadingError\nglcode PrepareLoadingError","url":"glcode.html#PrepareLoadingError"},{"doc":"glcode","title":"Prepared","content":"pub opaque type Prepared\n An opaque term holding prepared code.\n\nSynonyms:\nglcode.Prepared\nglcode Prepared","url":"glcode.html#Prepared"},{"doc":"glcode","title":"ReplacePathError","content":"pub type ReplacePathError {\n  ReplacePathBadName\n  ReplacePathBadDirectory\n  ReplacePathBadArgument(name: String, dir: String)\n}\n\nReplacePathBadName\n If Name is not found\n\nReplacePathBadDirectory\n If `dir` does not exist\n\nReplacePathBadArgument(name: String, dir: String)\n If `name` or `dir` is invalid\n\nSynonyms:\nglcode.ReplacePathError\nglcode ReplacePathError","url":"glcode.html#ReplacePathError"},{"doc":"glcode","title":"WhereIsFileError","content":"pub type WhereIsFileError {\n  WhereIsFileNonExisting\n}\n\nWhereIsFileNonExisting\n is returned if the file cannot be found\n\nSynonyms:\nglcode.WhereIsFileError\nglcode WhereIsFileError","url":"glcode.html#WhereIsFileError"},{"doc":"glcode","title":"Which","content":"pub type Which {\n  WhichPreloaded\n  WhichCoverCompiled\n  WhichFilename(filename: String)\n}\n\nWhichPreloaded\n\n\nWhichCoverCompiled\n\n\nWhichFilename(filename: String)\n\n\nSynonyms:\nglcode.Which\nglcode Which","url":"glcode.html#Which"},{"doc":"glcode","title":"WhichError","content":"pub type WhichError {\n  WhichNonExisting\n}\n\nWhichNonExisting\n\n\nSynonyms:\nglcode.WhichError\nglcode WhichError","url":"glcode.html#WhichError"},{"doc":"glcode","title":"all_available","content":"pub fn all_available() -&gt; List(Available)\n Returns a list of all available modules. A module is considered to be\n available if it either is loaded or would be loaded if called.\nSynonyms:\nglcode.all_available\nglcode all_available","url":"glcode.html#all_available"},{"doc":"glcode","title":"all_loaded","content":"pub fn all_loaded() -&gt; List(Loaded)\n Returns a list of all loaded modules.\nSynonyms:\nglcode.all_loaded\nglcode all_loaded","url":"glcode.html#all_loaded"},{"doc":"glcode","title":"append_path","content":"pub fn append_path(dir: String) -&gt; Result(Nil, AddPathError)\n Adds `dir` to the code path. The directory is added as the last directory in\n the new path. If the directory already exists in the path, it is not added.\nSynonyms:\nglcode.append_path\nglcode append_path","url":"glcode.html#append_path"},{"doc":"glcode","title":"append_paths","content":"pub fn append_paths(dirs: List(String)) -&gt; Nil\n Adds the directories in `dirs` to the end of the code path. If a already\n directory exists, it is not added.\nSynonyms:\nglcode.append_paths\nglcode append_paths","url":"glcode.html#append_paths"},{"doc":"glcode","title":"atomic_load","content":"pub fn atomic_load(\n  modules: List(Module),\n) -&gt; Result(Nil, List(AtomicLoadError))\n Tries to load all of the modules in the list `modules` atomically. That\n means that either all modules are loaded at the same time, or none of the\n modules are loaded if there is a problem with any of the modules.\n\n If it is important to minimize the time that an application is inactive\n while changing code, use [`prepare_loading`](#prepare_loading) and\n [`finish_loading`](#finish_loading) instead of `atomic_load`. Here is an\n example:\n\n     let assert Ok(prepared) = glcode.prepare_loading([&quot;module1&quot;, &quot;module2&quot;])\n     // Put the application into an inactive state or do any other\n     // preparation needed before changing the code.\n     let assert Ok(Nil) = glcode.finish_loading(Prepared)\n     // Resume the application.\nSynonyms:\nglcode.atomic_load\nglcode atomic_load","url":"glcode.html#atomic_load"},{"doc":"glcode","title":"clash","content":"pub fn clash() -&gt; Nil\n Searches all directories in the code path for module names with identical\n names and writes a report to `stdout`.\nSynonyms:\nglcode.clash\nglcode clash","url":"glcode.html#clash"},{"doc":"glcode","title":"compiler_dir","content":"pub fn compiler_dir() -&gt; String\n Returns the compiler library directory. Equivalent to `lib_dir(&quot;compiler&quot;)`.\nSynonyms:\nglcode.compiler_dir\nglcode compiler_dir","url":"glcode.html#compiler_dir"},{"doc":"glcode","title":"delete","content":"pub fn delete(module: String) -&gt; Bool\n Removes the current code for `module`, that is, the current code for\n `module` is made old. This means that processes can continue to execute the\n code in the module, but no external function calls can be made to it.\n\n Returns `True` if successful, or `False` if there is old code for `module`\n that must be purged first, or if `module` is not a (loaded) module.\nSynonyms:\nglcode.delete\nglcode delete","url":"glcode.html#delete"},{"doc":"glcode","title":"delete_path","content":"pub fn delete_path(\n  dir: PathOrName,\n) -&gt; Result(Nil, DeletePathError)\n Deletes a directory from the code path. The argument can be a `Name`, in\n which case the directory with the name `.../Name[-Vsn][/ebin]` is deleted\n from the code path. Also, the complete directory `Path` can be specified\n as argument.\nSynonyms:\nglcode.delete_path\nglcode delete_path","url":"glcode.html#delete_path"},{"doc":"glcode","title":"ensure_loaded","content":"pub fn ensure_loaded(\n  module: String,\n) -&gt; Result(String, EnsureLoadedError)\n Tries to load a module in the same way as `load_file`, unless the module is\n already loaded. However, in embedded mode it does not load a module that is\n not already loaded, but returns [`EnsureLoadedEmbedded`](#EnsureLoadedEmbedded)\n instead. See [`EnsureLoadedError`](#EnsureLoadedError) for a description of\n other possible error reasons.\nSynonyms:\nglcode.ensure_loaded\nglcode ensure_loaded","url":"glcode.html#ensure_loaded"},{"doc":"glcode","title":"ensure_modules_loaded","content":"pub fn ensure_modules_loaded(\n  modules: List(String),\n) -&gt; Result(Nil, List(EnsureModulesLoadedError))\n Tries to load any modules not already loaded in the list `modules` in the\n same way as [`load_file`](#load_file).\nSynonyms:\nglcode.ensure_modules_loaded\nglcode ensure_modules_loaded","url":"glcode.html#ensure_modules_loaded"},{"doc":"glcode","title":"finish_loading","content":"pub fn finish_loading(\n  prepared: Prepared,\n) -&gt; Result(Nil, List(FinishLoadingError))\n Tries to load code for all modules that have been previously prepared\n by [`prepare_loading`](#prepare_loading). The loading occurs atomically,\n meaning that either all modules are loaded at the same time, or none of the\n modules are loaded.\nSynonyms:\nglcode.finish_loading\nglcode finish_loading","url":"glcode.html#finish_loading"},{"doc":"glcode","title":"get_doc","content":"pub fn get_doc(module: String) -&gt; Result(DocsV1, GetDocError)\n Searches the code path for EEP-48 style documentation and returns it if\n available. If no documentation can be found the function tries to generate\n documentation from the debug information in the module.\n\n For more information about the documentation chunk see Documentation Storage\n and Format in Kernel&#39;s User&#39;s Guide.\n\n For now this returns a dynamic value since coming up with a sensible Gleam\n type for it is crazy.\nSynonyms:\nglcode.get_doc\nglcode get_doc","url":"glcode.html#get_doc"},{"doc":"glcode","title":"get_mode","content":"pub fn get_mode() -&gt; Mode\n Returns an atom describing the mode of the code server: interactive or\n embedded. This information is useful when an external entity (for example,\n an IDE) provides additional code for a running node. If the code server is\n in interactive mode, it only has to add the path to the code. If the code\n server is in embedded mode, the code must be loaded with\n [`load_binary`](#load_binary).\nSynonyms:\nglcode.get_mode\nglcode get_mode","url":"glcode.html#get_mode"},{"doc":"glcode","title":"get_object_code","content":"pub fn get_object_code(\n  module: String,\n) -&gt; Result(ObjectCode, LoadError)\n This function can be used to load object code on remote Erlang nodes.\n Argument `binary` must contain object code for `module`. `filename` is only\n used by the code server to keep a record of from which file the object code\n for `module` comes. Thus, `filename` is not opened and read by the code\n server.\nSynonyms:\nglcode.get_object_code\nglcode get_object_code","url":"glcode.html#get_object_code"},{"doc":"glcode","title":"is_loaded","content":"pub fn is_loaded(module: String) -&gt; Result(IsLoaded, Nil)\n Checks if `module` is loaded. If it is, the loaded filename is returned,\n otherwise `Error(Nil)`.\n Normally, `IsLoaded` contains the the absolute `filename` from which the code is\n obtained. If the module is preloaded (see\n [script(4)](https://www.erlang.org/doc/man/script)\n ), then it returns `IsPreloaded`. If\n the module is Cover-compiled (see\n [cover(3)](https://www.erlang.org/doc/man/cover)\n ), it returns `IsCoverCompiled`.\nSynonyms:\nglcode.is_loaded\nglcode is_loaded","url":"glcode.html#is_loaded"},{"doc":"glcode","title":"is_sticky","content":"pub fn is_sticky(module: String) -&gt; Bool\n Returns `True` if `module` is the name of a module that has been loaded from\n a sticky directory (in other words: an attempt to reload the module will\n fail), or `False` if `module` is not a loaded module or is not sticky.\nSynonyms:\nglcode.is_sticky\nglcode is_sticky","url":"glcode.html#is_sticky"},{"doc":"glcode","title":"lib_dir","content":"pub fn lib_dir() -&gt; String\n Returns the library directory, `$OTPROOT/lib`, where `$OTPROOT` is the root\n directory of Erlang/OTP.\n\n ### Example:\n\n     glcode.lib_dir()\n     &quot;/nix/store/gnm9kc4qnayb7wbhmnsq0w6yqgh7xgn3-erlang-25.3.2.9/lib/erlang/lib&quot;\nSynonyms:\nglcode.lib_dir\nglcode lib_dir","url":"glcode.html#lib_dir"},{"doc":"glcode","title":"lib_dir_of","content":"pub fn lib_dir_of(name: String) -&gt; Result(String, LibDirOfError)\n Returns the path for the &quot;library directory&quot;, the top directory, for an\n application Name located under `$OTPROOT/lib` or on a directory referred to\n with environment variable `ERL_LIBS`.\n\n If a regular directory called `name` or `name-Vsn` exists in the code\n path with an `ebin` subdirectory, the path to this directory is returned\n (not the ebin directory).\n If the directory refers to a directory in an archive, the archive name is\n stripped away before the path is returned. For example, if directory `/usr/\n local/otp/lib/mnesia-4.2.2.ez/mnesia-4.2.2/ebin` is in the path, `/usr/local/\n otp/lib/mnesia-4.2.2/ebin` is returned. This means that the library directory\n for an application is the same, regardless if the application resides in an\n archive or not.\n\n ### Example:\n\n     &gt; glcode.lib_dir(&quot;mnesia&quot;)\n     &quot;/nix/store/gnm9kc4qnayb7wbhmnsq0w6yqgh7xgn3-erlang-25.3.2.9/lib/erlang/lib/mnesia-4.21.4.2&quot;\n\n Returns an error if `name` is not the name of an application under\n `$OTPROOT/lib` or on a directory referred to through environment variable\n `ERL_LIBS`.\nSynonyms:\nglcode.lib_dir_of\nglcode lib_dir_of","url":"glcode.html#lib_dir_of"},{"doc":"glcode","title":"lib_dir_of_sub","content":"pub fn lib_dir_of_sub(\n  module: String,\n  dir: String,\n) -&gt; Result(String, LibDirOfError)\n Returns the path to a subdirectory directly under the top directory of an application. Normally the subdirectories reside under the top directory for the application, but when applications at least partly reside in an archive, the situation is different. Some of the subdirectories can reside as regular directories while others reside in an archive file. It is not checked whether this directory exists.\n\n Example:\n\n     &gt; glcode.lib_dir(&quot;megaco&quot;, &quot;priv&quot;).\n     &quot;/usr/local/otp/lib/megaco-3.9.1.1/priv&quot;\nSynonyms:\nglcode.lib_dir_of_sub\nglcode lib_dir_of_sub","url":"glcode.html#lib_dir_of_sub"},{"doc":"glcode","title":"load_abs","content":"pub fn load_abs(filename: String) -&gt; Result(String, LoadError)\n Same as `load_file`, but `filename` is an absolute or relative filename.\n The code path is not searched. It returns a value in the same way as\n `load_file`. Notice that Filename must not contain the extension (for\n example, `.beam`) because `load_abs` adds the correct extension.\nSynonyms:\nglcode.load_abs\nglcode load_abs","url":"glcode.html#load_abs"},{"doc":"glcode","title":"load_binary","content":"pub fn load_binary(\n  module: String,\n  filename: String,\n  binary: BitArray,\n) -&gt; Result(String, LoadError)\n This function can be used to load object code on remote Erlang nodes.\n Argument `binary` must contain object code for `module`. `filename` is only\n used by the code server to keep a record of from which file the object code\n for `module` comes. Thus, `filename` is not opened and read by the code\n server.\nSynonyms:\nglcode.load_binary\nglcode load_binary","url":"glcode.html#load_binary"},{"doc":"glcode","title":"load_file","content":"pub fn load_file(name: String) -&gt; Result(String, LoadError)\n Tries to load the Erlang module `module`, using the code path. It looks for\n the object code file with an extension corresponding to the Erlang machine\n used, for example, `module`.beam. The loading fails if the module name found\n in the object code differs from the name `module`. `load_binary` must be\n used to load object code with a module name that is different from the file\n name.\nSynonyms:\nglcode.load_file\nglcode load_file","url":"glcode.html#load_file"},{"doc":"glcode","title":"modified_modules","content":"pub fn modified_modules() -&gt; List(Module)\n Returns the list of all currently loaded modules for which\n [`module_status`](#module_status)\n returns modified. See also [`all_loaded`](#all_loaded).\nSynonyms:\nglcode.modified_modules\nglcode modified_modules","url":"glcode.html#modified_modules"},{"doc":"glcode","title":"module_status","content":"pub fn module_status(modules: List(String)) -&gt; List(ModuleStatus)\n Preloaded modules are always reported as loaded, without inspecting the\n contents on disk. Cover compiled modules will always be reported as modified\n if an object file exists, or as removed otherwise. Modules whose load path\n is an empty string (which is the convention for auto-generated code) will\n only be reported as Loaded or NotLoaded.\nSynonyms:\nglcode.module_status\nglcode module_status","url":"glcode.html#module_status"},{"doc":"glcode","title":"objfile_extension","content":"pub fn objfile_extension() -&gt; String\n Returns the object code file extension corresponding to the Erlang machine\n used, namely `.beam`.\nSynonyms:\nglcode.objfile_extension\nglcode objfile_extension","url":"glcode.html#objfile_extension"},{"doc":"glcode","title":"prepare_loading","content":"pub fn prepare_loading(\n  modules: List(Module),\n) -&gt; Result(Prepared, List(PrepareLoadingError))\n Prepares to load the modules in the list `modules`. Finish the loading by\n calling [`finish_loading(prepared)`](#finish_loading).\nSynonyms:\nglcode.prepare_loading\nglcode prepare_loading","url":"glcode.html#prepare_loading"},{"doc":"glcode","title":"prepend_path","content":"pub fn prepend_path(dir: String) -&gt; Result(Nil, AddPathError)\n Adds `dir` to the beginning of the code path. If the directory already\n exists, it is removed from the old position in the code path.\nSynonyms:\nglcode.prepend_path\nglcode prepend_path","url":"glcode.html#prepend_path"},{"doc":"glcode","title":"prepend_paths","content":"pub fn prepend_paths(dirs: List(String)) -&gt; Nil\n Traverses `dirs` and adds each directory to the beginning of the code path.\n This means that the order of `dirs` is reversed in the resulting code path.\n For example, if you add `[dir1, dir2]`, the resulting path will be\n `[dir2, dir1, ..old_code_path]`.\n If a directory already exists in the code path, it is removed from the old\n position.\nSynonyms:\nglcode.prepend_paths\nglcode prepend_paths","url":"glcode.html#prepend_paths"},{"doc":"glcode","title":"priv_dir","content":"pub fn priv_dir(name: String) -&gt; Result(Nil, String)\n Returns the path to the priv directory in an application. Equivalent to\n `lib_dir(name, &quot;priv&quot;)`.\nSynonyms:\nglcode.priv_dir\nglcode priv_dir","url":"glcode.html#priv_dir"},{"doc":"glcode","title":"purge","content":"pub fn purge(module: String) -&gt; Bool\n Purges the code for Module, that is, removes code marked as old. If some processes still linger in the old code, these processes are killed before the code is removed.\n Returns true if successful and any process is needed to be killed, otherwise false.\nSynonyms:\nglcode.purge\nglcode purge","url":"glcode.html#purge"},{"doc":"glcode","title":"replace_path","content":"pub fn replace_path(\n  name: String,\n  dir: String,\n) -&gt; Result(Nil, ReplacePathError)\n Replaces an old occurrence of a directory named `.../Name[-Vsn][/ebin]` in the\n code path, with `dir`. If `name` does not exist, it adds the new directory `dir`\n last in the code path. The new directory must also be named\n `.../Name[-Vsn][/ebin]`. This function is to be used if a new version of the\n directory (library) is added to a running system.\nSynonyms:\nglcode.replace_path\nglcode replace_path","url":"glcode.html#replace_path"},{"doc":"glcode","title":"root_dir","content":"pub fn root_dir() -&gt; String\n root_dir() -&gt; file:filename()\n Returns the root directory of Erlang/OTP, which is the directory where it is installed.\n Example:\n &gt; code:root_dir().\n &quot;/usr/local/otp&quot;\nSynonyms:\nglcode.root_dir\nglcode root_dir","url":"glcode.html#root_dir"},{"doc":"glcode","title":"soft_purge","content":"pub fn soft_purge(module: String) -&gt; Bool\n Purges the code for `Module`, that is, removes code marked as old, but only\n if no processes linger in it. Returns `False` if the module cannot be purged\n because of processes lingering in old code, otherwise `True`.\nSynonyms:\nglcode.soft_purge\nglcode soft_purge","url":"glcode.html#soft_purge"},{"doc":"glcode","title":"stick_dir","content":"pub fn stick_dir(dir: String) -&gt; Result(Nil, Nil)\n Marks `dir` as sticky.\nSynonyms:\nglcode.stick_dir\nglcode stick_dir","url":"glcode.html#stick_dir"},{"doc":"glcode","title":"unstick_dir","content":"pub fn unstick_dir(dir: String) -&gt; Result(Nil, Nil)\n Unsticks a directory that is marked as sticky.\nSynonyms:\nglcode.unstick_dir\nglcode unstick_dir","url":"glcode.html#unstick_dir"},{"doc":"glcode","title":"where_is_file","content":"pub fn where_is_file(\n  filename: String,\n) -&gt; Result(String, WhereIsFileError)\n Searches the code path for `filename`, a file of arbitrary type. If found,\n the full name is returned. The function can be useful, for example, to\n locate application resource files.\nSynonyms:\nglcode.where_is_file\nglcode where_is_file","url":"glcode.html#where_is_file"},{"doc":"glcode","title":"which","content":"pub fn which(module: String) -&gt; Result(Which, WhichError)\n If the module is not loaded, this function searches the code path for\n the first file containing object code for `module` and returns the absolute\n filename.\n\n If the module is loaded, it returns the name of the file containing the\n loaded object code.\n\n If the module is preloaded, `WhichPreloaded` is returned.\n\n If the module is Cover-compiled, `WhichCoverCompiled` is returned.\n\n If the module cannot be found, `WhichNonExisting` is returned.\n\nSynonyms:\nglcode.which\nglcode which","url":"glcode.html#which"},{"doc":"glcode","title":"glcode","content":" This module contains the interface to the Erlang code server, which deals\n with the loading of compiled code into a running Erlang runtime system.\n\n The runtime system can be started in interactive or embedded mode. Which\n one is decided by the command-line flag `-mode`:\n\n     erl -mode interactive\n\n The modes are as follows:\n\n * In interactive mode, which is default, only some code is loaded during\n   system startup, basically the modules needed by the runtime system.\n   Other code is dynamically loaded when first referenced. When a call to a\n   function in a certain module is made, and the module is not loaded, the\n   code server searches for and tries to load the module.\n\n * In embedded mode, modules are not auto loaded. Trying to use a module\n   that has not been loaded results in an error. This mode is recommended\n   when the boot script loads all modules, as it is typically done in OTP\n   releases. (Code can still be loaded later by explicitly ordering the code\n   server to do so).\n\n To prevent accidentally reloading of modules affecting the Erlang runtime\n system, directories `kernel`, `stdlib`, and `compiler` are considered\n *sticky*. This means that the system issues a warning and rejects the\n request if a user tries to reload a module residing in any of them. The\n feature can be disabled by using command-line flag `-nostick`.\n\n ## Code Path\n\n In interactive mode, the code server maintains a search path, usually\n called the code path, consisting of a list of directories, which it\n searches sequentially when trying to load a module.\n \n Initially, the code path consists of the current working directory and\n all Erlang object code directories under library directory `$OTPROOT/lib`,\n where `$OTPROOT` is the installation directory of Erlang/OTP, `root_dir()`.\n Directories can be named `Name[-Vsn]` and the `code` server, by default,\n chooses the directory with the highest version number among those having\n the same Name. Suffix `-Vsn` is optional. If an ebin directory exists under\n `Name[-Vsn]`, this directory is added to the code path.\n \n Environment variable `ERL_LIBS` (defined in the operating system) can be\n used to define more library directories to be handled in the same way as\n the standard OTP library directory described above, except that directories\n without an ebin directory are ignored.\n \n All application directories found in the additional directories appear\n before the standard OTP applications, except for the Kernel and STDLIB\n applications, which are placed before any additional applications. In other\n words, modules found in any of the additional library directories override\n modules with the same name in OTP, except for modules in Kernel and STDLIB.\n \n Environment variable `ERL_LIBS` (if defined) is to contain a\n colon-separated (for Unix-like systems) or semicolon-separated (for\n Windows) list of additional libraries.\n \n ### Example:\n \n On a Unix-like system, `ERL_LIBS` can be set to the following\n \n     /usr/local/jungerl:/home/some_user/my_erlang_lib\n\n On Windows, use semi-colon as separator.\n \n ## Current and Old Code\n\n The code for a module can exist in two variants in a system: *current code*\n and *old code*. When a module is loaded into the system for the first time,\n the module code becomes &#39;current&#39; and the global export table is updated\n with references to all functions exported from the module.\n \n If then a new instance of the module is loaded (for example, because of\n error correction), the code of the previous instance becomes &#39;old&#39;, and all\n export entries referring to the previous instance are removed. After that,\n the new instance is loaded as for the first time, and becomes &#39;current&#39;.\n \n Both old and current code for a module are valid, and can even be evaluated\n concurrently. The difference is that exported functions in old code are\n unavailable. Hence, a global call cannot be made to an exported function\n in old code, but old code can still be evaluated because of processes\n lingering in it.\n \n If a third instance of the module is loaded, the code server removes\n (purges) the old code and any processes lingering in it are terminated.\n Then the third instance becomes &#39;current&#39; and the previously current code\n becomes &#39;old&#39;.\n \n For more information about old and current code, and how to make a\n process switch from old to current code, see section &quot;Compilation and\n Code Loading&quot; in the\n [Erlang Reference Manual](https://www.erlang.org/doc/reference_manual/code_loading).","url":"glcode.html"}]);